#version 430 core
layout(location=0) out vec4 FragColor;
  
in vec2 TexCoords;

uniform sampler2D emissionTexture;
layout(location=0) uniform bool horizontal;

const float kernel [5] = {0.227027, 0.1945946, 0.1216216, 0.054054, 0.016216};

void main()
{ 
	vec2 offset = 1.0 / textureSize(emissionTexture, 0);
	
	vec3 color = texture(emissionTexture, TexCoords).rgb * kernel[0];
	
	if(horizontal){
		for(int i = 1; i < 5; i+=2) {
			float weight = kernel[i]+kernel[i+1];
			float off = offset.x;
			off = (off*i*kernel[i]+off*(i+1)*kernel[i])/weight;
			color += texture(emissionTexture, TexCoords + vec2(off,0.0)).rgb * weight;
			color += texture(emissionTexture, TexCoords - vec2(off,0.0)).rgb * weight;
		}
	}
	else {
		for(int i = 1; i < 5; i+=2) {
			float weight = kernel[i]+kernel[i+1];
			float off = offset.y;
			off = (off*i*kernel[i]+off*(i+1)*kernel[i])/weight;
			color += texture(emissionTexture, TexCoords + vec2(0.0, off)).rgb * weight;
			color += texture(emissionTexture, TexCoords - vec2(0.0, off)).rgb * weight;
		}

	}
	
	FragColor = vec4(color, 1.0);
}