#version 430

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 aTexCoords;
layout(location = 3) in vec2 aLMCoords;
layout(location = 4) in vec3 aTangent;

layout(location = 1) uniform mat4 mvpMatrix;
layout(location = 2) uniform mat4 normalMatrix;
layout(location = 3) uniform mat4 mvMatrix;
layout(location = 4) uniform mat4 viewMatrix;

out vec3 n;
out vec3 fragmentPosition;
out vec2 TexCoord;
out vec2 LMCoord;
out mat3 TBN;

void main(void) {

    gl_Position = mvpMatrix * vec4(position, 1.0);
	n = normalize((normalMatrix * vec4(normal,1)).xyz);	
	fragmentPosition = (mvMatrix * vec4(position,1.0)).xyz;
	TexCoord = aTexCoords;
	LMCoord = aLMCoords;
	
	vec3 t = normalize((mvMatrix * vec4(aTangent,0.0)).xyz);
	vec3 n = normalize((mvMatrix * vec4(normal,0.0)).xyz);
	vec3 b = normalize(cross(n, t));
	TBN = mat3(t,b,n);
}